#!/bin/bash

echo -e "\e[1;32mGenerating storyboard constraints....\n\e[0m"

./storyboard1 -input $1 -output output.sk

echo -e "\e[1;32mSketch constraints generated. Running the Sketch synthesizer....\n\e[0m"

sketch output.sk > sketch_output.txt

echo -e "\e[1;32mSketch synthesized the solution. Generating the code....\n\e[0m"

awk '
BEGIN    {foundF=0; foundFC=0; fVal=-1; fcVal=-1; print ":- dynamic assignment/2." > "fAssign.pl"; print ":- dynamic newencoding/2." > "fAssign.pl"; }
/void\ f[0-9]+/ {foundF=1; 
                 foundFC=0; 
                 match($0, /f([0-9]+(a?|b?))/, arr);
                 fVal = arr[1];
                }
/fc[0-9]+/ {
               if(foundF==1 && foundFC==0){
               foundF=0; foundFC=1;
               match($0, /fc([0-9]+)/, arr);
               assign = "assignment(f" fVal "," arr[1] ").";
               print assign > "fAssign.pl";
               fVal = -1;
               }
           }

/fromState.[a-zA-Z0-9]+ = fromState.[a-zA-Z0-9]+/ {
               if(foundF==1 && foundFC==0){
               foundF=0; foundFC=1;
match($0,/fromState.([a-zA-Z0-9]+) = fromState.([a-zA-Z0-9]+)/, arr);
print "newencoding(f" fVal "," "\x27" arr[1] "=" arr[2] "\x27" ")." > "fAssign.pl";
}
}
/fromState.[a-zA-Z0-9]+ = fromState.[a-zA-Z0-9]+\[fromState.[a-zA-Z0-9]+\]/ {
               if(foundF==1 && foundFC==0){
               foundF=0; foundFC=1;

match($0,/fromState.([a-zA-Z0-9])+ = fromState.([a-zA-Z0-9])+\[fromState.([a-zA-Z0-9])+\]/, arr);
print "newencoding(f" fVal "," "\x27" arr[1] "=" arr[3] "." arr[2] "\x27" ")." > "fAssign.pl";
}
}
/fromState.[a-zA-Z0-9]+\[fromState.[a-zA-Z0-9]+\] = fromState\.[a-zA-Z0-9]+/ {
               if(foundF==1 && foundFC==0){
               foundF=0; foundFC=1;
match($0,/fromState.([a-zA-Z0-9]+)\[fromState.([a-zA-Z0-9]+)\] = fromState\.([a-zA-Z0-9]+)/, arr);
print "newencoding(f" fVal "," "\x27" arr[2] "." arr[1] "=" arr[3] "\x27" ")." > "fAssign.pl";
}
}
/fromState.[a-zA-Z0-9]+\[fromState.[a-zA-Z0-9]+\] = fromState.[a-zA-Z0-9]+\[fromState.[a-zA-Z0-9]+\]/ {
               if(foundF==1 && foundFC==0){
               foundF=0; foundFC=1;
match($0,/fromState.([a-zA-Z0-9])+\[fromState.([a-zA-Z0-9])+\] = fromState.([a-zA-Z0-9])+\[fromState.([a-zA-Z0-9])+/, arr);
print "newencoding(f" fVal ","  "\x27" arr[2] "." arr[1] "=" arr[4] "." arr[3] "\x27" ")." > "fAssign.pl";
}
}
/int rhs = fromState.[a-zA-Z0-9]+\[fromState.[a-zA-Z0-9]+\]/ {
              match($0,/fromState.([a-zA-Z0-9]+)\[fromState.([a-zA-Z0-9]+)/, arr);
rhs = arr[2] "." arr[1];
}
/fromState.[a-zA-Z0-9]+ = rhs;/ {
               if(foundF==1 && foundFC==0){
               foundF=0; foundFC=1;
match($0,/fromState.([a-zA-Z0-9]+)/, arr);
print "newencoding(f" fVal "," "\x27" arr[1] "=" rhs "\x27" ")." > "fAssign.pl";
}
}
/fromState.[a-zA-Z0-9]+\[fromState.[a-zA-Z0-9]+\] = rhs;/ {
               if(foundF==1 && foundFC==0){
               foundF=0; foundFC=1;
match($0,/fromState.([a-zA-Z0-9]+)\[fromState.([a-zA-Z0-9]+)\]/, arr);
print "newencoding(f" fVal "," "\x27" arr[2] "." arr[1] "=" rhs "\x27" ")." > "fAssign.pl";
}}

' sketch_output.txt

./postProcessor1
